#ifndef _TaS_INPUT_HH_
#define _TaS_INPUT_HH_

#include <iostream>
#include <vector>
#include <cstdlib>

using namespace std;

class TaS_Input 
{
  friend ostream& operator<<(ostream& os, const TaS_Input& ts);
public:
  TaS_Input(string file_name);
  unsigned Actors() const { return actors; }
  unsigned Scenes() const { return scenes; }
  unsigned Locations() const { return locations; }

  unsigned ActorCost(unsigned a) const { return actor_cost[a]; }
  unsigned LocationCost(unsigned l) const { return location_cost[l]; }
  unsigned SceneDuration(unsigned s) const { return scene_duration[s]; }
  unsigned SceneLocation(unsigned s) const { return scene_location[s]; }
  bool Presence(unsigned a, unsigned s) const { return presence[a][s]; }
  pair<unsigned,unsigned> Precedence(unsigned i) const { return precedence[i]; }
  unsigned Precedences() const { return precedence.size(); }
private:
  unsigned actors, scenes, locations;
  vector<unsigned> actor_cost;
  vector<unsigned> location_cost;
  vector<unsigned> scene_duration;
  vector<unsigned> scene_location;
  vector<vector<bool>> presence;  // Actors X Scenes
  vector<pair<unsigned,unsigned>> precedence;
};

class TaS_Output 
{
  friend ostream& operator<<(ostream& os, const TaS_Output& out);
  friend istream& operator>>(istream& is, TaS_Output& out);
public:
  TaS_Output(const TaS_Input& i);
  TaS_Output& operator=(const TaS_Output& out);
  unsigned operator[](unsigned i) const { return scenes[i]; }
  void Reset();
  void Swap(unsigned p1, unsigned p2);
//  unsigned& operator[](unsigned i) { return scenes[i]; }
  unsigned LocationsCost() const;
  unsigned TalentCost() const;
  unsigned PrecedenceViolations() const;
private:
  const TaS_Input& in;
  vector<unsigned> scenes, position;
};
#endif

