#include <iostream>
#include <fstream>
#include <cstdlib>
#include "TaS_Data.hh"

int main(int argc, char* argv[])
{
  string instance, solution;
  ifstream is;

  if (argc == 1)
    {
      cout << "Name of the file containing the instance:";
      cin >> instance;
      cout << "Name of the file containing the solution:";
      cin >> solution;
    }
  else if (argc == 3)
    {
      instance = argv[1];
      solution = argv[2];
    }
  else
    {
      cerr << "Usage: " << argv[0] << " [input_file solution_file]" << endl;
      exit(1);
    }

  TaS_Input in(instance);
  TaS_Output out(in);
  is.open(solution);
  is >> out;
  is.close();

  unsigned LC = out.LocationsCost();
  unsigned AC = out.TalentCost();
  cout << in << endl;
  cout << out << endl;
  cout << "Precedence violations: " << out.PrecedenceViolations() << endl;	
  cout << "Location footprint: " << LC << endl;	
  cout << "Talent footprint: " << AC << endl;	
  cout << "Total footprint: " <<AC+LC <<endl;
  return 0;
}

